/* ** apply.c ************************************ */
/* Get Message from Client and do work for it */
/* *********************************************** */

/* -- Include File ------------------------------- */
#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <errno.h>

#include <sys/time.h>


#include "tuitated.h"
#include "protocol.h"
#include "clientlist.h"
#include "game.h"
#include "judge.h"
#include "sendmessage.h"
#include "receivemessage.h"
#include "handlist.h"

/* -- Prototype Declerations  -------------------- */
#define sboolrand srand
int boolrand( void );

void MsgHelp( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgMode( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgQuit( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgEmergency( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgGet( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgGame( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgChallengerlist( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgChallenge( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgAccept( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgRefuse( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgMoveAndDrop( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgGiveup( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgCheat( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgView( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgNotation( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgManagenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgGamelist( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgViewgame( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgNotationlist( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgViewnotation( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgDeletenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgSavenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgUnsavenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgEmptyLine( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgNotYetOnePacket( CLIENTDATA *client, CLIENT_MESSAGE *msg );
void MsgError( CLIENTDATA *client, CLIENT_MESSAGE *msg );

void TerminateAllGames( void );

/* -- Global Data -------------------------------- */
CLIENTDATA *ClientList;

void (*(ClientMessageHandlers[MSGKEY_NUM]))(CLIENTDATA *client, CLIENT_MESSAGE *msg) = {
    MsgMode,
    MsgHelp,
    MsgQuit,
    
    MsgGame,
    MsgView,
    MsgNotation,
    MsgManagenotation,
    MsgGet,

    MsgChallengerlist,
    MsgChallenge,
    MsgAccept,
    MsgRefuse,

    MsgMoveAndDrop,     /* MOVE */
    MsgMoveAndDrop,     /* DROP */
    MsgGiveup,
    MsgCheat,
    
    MsgGamelist,
    MsgViewgame,

    MsgNotationlist,
    MsgViewnotation,

    MsgDeletenotation,
    MsgSavenotation,
    MsgUnsavenotation,
    
    MsgEmptyLine,
    MsgNotYetOnePacket,

    MsgEmergency,
    MsgError,
};


/* ** Func Apply ********************************* */
/* main routine of tuitate */
void Apply( void )
{
/* -- Local Data --------------------------------- */
    fd_set WriteFdSet;
    fd_set ReadFdSet;
    int nfds; /* number of file discriptor */
    int SelectRet;
    int NewSocket;
/* -- Operation ---------------------------------- */
    ClientList = NULL;
    /* prepare random */
    sboolrand( getpid() );
    /* appling loop */
    while( 1 ) {
        /* prepare WriteFdSet */
        FD_ZERO( &WriteFdSet );
        SetSocketDiscriptorToWrite( &WriteFdSet );
        /* prepare ReadFdSet */
        FD_ZERO( &ReadFdSet );
        FD_SET( ApplySocket, &ReadFdSet );
        SetSocketDiscriptorToRead( &ReadFdSet );
        /* prepare FD number */
        nfds = SocketDiscriptorNum() + 1;
        nfds = ( nfds < ApplySocket + 1 ) ? ApplySocket + 1 : nfds;
        /* select */
        SelectRet = select( nfds, &ReadFdSet, &WriteFdSet, NULL, NULL );
        if( SelectRet < 0 ) { /* Error Occured */
            if( errno == EINTR ) {
                Err( "Signal received." );
                continue;
            }
            Err( "select %d, Unknown error.", errno );
        } else if( SelectRet == 0 ) { /* Timeout Occured */
        } else { /* Data written */
            /* New client appear. */
            if( FD_ISSET( ApplySocket, &ReadFdSet ) ) {
                struct linger ling;
                int iRet;
                NewSocket = accept( ApplySocket, NULL, NULL);
                if( NewSocket < 0 ) {
                    /* System call is Interupted by SIGNAL. */
                    if( errno == EINTR ) {
                        Err( "accept. interupted ... %d", errno );
                        continue;
                    }
                    Err( "accept. %d", errno );
                    TerminateAllGames();
                    exit( 1 );
                }
                /* set socket options */
                if( fcntl( NewSocket, F_SETFL, O_NDELAY ) < 0 ) {
                    Err( "fcntl. %d", errno );
                }
#ifndef MAX_SECS_TO_LINGER
#define MAX_SECS_TO_LINGER 30
#endif
                ling.l_onoff = TRUE;
                ling.l_linger = 30;
                iRet = setsockopt( NewSocket, SOL_SOCKET, SO_LINGER,
                                   &ling, sizeof( ling )  );
                if( iRet < 0 ) {
                    Err( "setsockopt(LINGER)" );
                }
                AddClient( NewSocket );
            } else { /* a client sends a packet */
                CLIENTDATA *client;
                client = MatchSocketDiscriptor( &WriteFdSet );
                if( client != NULL ) {
                    /* we can write data into the socket! */
                    if( SendMessage( client ) ) { /* write error */
                        MsgEmergency( client, NULL );
                    }
                }else if((client = MatchSocketDiscriptor(&ReadFdSet)) != NULL){
                    /* we can read data out of the socket! */
                    CLIENT_MSGKEY ReadMessageRet;
                    CLIENT_MESSAGE msg;
                    int ShouldSelect = FALSE;
                    while( !ShouldSelect ) {
                        ReadMessageRet
                            = ReadMessage( client, &msg, &ShouldSelect );
                        ClientMessageHandlers[ReadMessageRet]( client, &msg );
                    }
                } else {
                    /* why reach here? */
                    Err( "select." );
                }
            }
        }
    }
} /* Apply */


/* ** Func MsgEmptyLine ********************************** */
/* Say what func this is */
void MsgEmptyLine( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_GET ) {       /* if waiting next empty line.. */
        SendFile( client, client->name );
        RemoveClient( client );
    }
} /* MsgEmptyLine */

/* ** Func MsgNotYetOnePacket ***************************** */
/* Say what func this is */
void MsgNotYetOnePacket( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    return;
} /* MsgNotYetOnePacket */

/* ** Func MsgHelp ********************************** */
/* Say what func this is */
void MsgHelp( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( SendHelp( client ) ) DeleteClient( client );
} /* MsgHelp */

/* ** Func MsgMode ********************************** */
/* Say what func this is */
void MsgMode( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( SendMode( client )) DeleteClient( client );
} /* MsgMode */

/* ** Func MsgQuit ********************************** */
/*
 * Handler called when the client should removed.
 * argument 'msg' NOT used in this func.
 */
void MsgQuit( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
    NOTATION_HANDDATA NotationHandData;
/* -- Operation ---------------------------------- */
    switch( client->mode ) {
      case MODE_GAME:
        /* Save Hand Data for Notation */
        NotationHandData.key = NOTATION_END;
        NotationHandData.winner = NOSIDE;
        NotationHandData.reason_of_end = EMERGENCE;
        AddHand( client->game, &NotationHandData );
        /* Send Message to the other Client */
        if( !SendEndID( THEOTHERPLAYER(client),DRAW,EMERGENCE ) ) {
            SendEndData( THEOTHERPLAYER(client),client->game );
        }
        /* SaveNotation into file */
        SaveNotation( client->game );
        /* Send Hand Data to Viewer */
        SendEachViewerHandData( client->game, &NotationHandData );
        /* Clean up Data */
        CleanGame( client->game );
        break;
      case MODE_SELECTENEMY:
        if( client->Selecting != NULL ) {
            client->Selecting->Selected = NULL;
        } else if( client->Selected != NULL ) {
            client->Selected->Selecting = NULL;
            if( SendNotExist( client->Selected ) )
                DeleteClient( client->Selected );
        }
        RemoveClient( client );
        break;
      case MODE_VIEW:
        RemoveViewer( client->game, client );
        break;
      default:
        DeleteClient( client );
        break;
    }
} /* MsgQuit */

/* ** Func MsgEmergency ********************************** */
/*
 * Handler called when the client should be forced to be removed.
 * argument 'msg' NOT used in this func.
 */
void MsgEmergency( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
    NOTATION_HANDDATA NotationHandData;
/* -- Operation ---------------------------------- */
    switch( client->mode ) {
      case MODE_GAME:
        /* Save Hand Data for Notation */
        NotationHandData.key = NOTATION_END;
        NotationHandData.winner = NOSIDE;
        NotationHandData.reason_of_end = EMERGENCE;
        AddHand( client->game, &NotationHandData );
        /* Send Message to the other Client */
        if( !SendEndID( THEOTHERPLAYER(client),DRAW,EMERGENCE ) ) {
            SendEndData( THEOTHERPLAYER(client),client->game );
        }
        /* SaveNotation into file */
        SaveNotation( client->game );
        /* Send Hand Data to Viewer */
        SendEachViewerHandData( client->game, &NotationHandData );
        /* Clean up Data */
        CleanGameWithEmergence( client->game, client );
        break;
      case MODE_SELECTENEMY:
        if( client->Selecting != NULL ) {
            client->Selecting->Selected = NULL;
        } else if( client->Selected != NULL ) {
            client->Selected->Selecting = NULL;
            if( SendNotExist( client->Selected ) )
                DeleteClient( client->Selected );
        }
        DeleteClient( client );
        break;
      case MODE_VIEW:
        DeleteViewer( client->game, client );
        break;
      default:
        DeleteClient( client );
        break;
    }
} /* MsgEmergency */

/* ** Func MsgGet ********************************** */
/* Say what func this is */
void MsgGet( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_NEUTRAL ) {
        client->mode = MODE_GET;        /* mode to wait next empty line */
        client->name = msg->name;
    }
} /* MsgGet */

/* ** Func MsgGame ********************************** */
/* Say what func this is */
void MsgGame( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    client->name = msg->name;
    client->mailaddress = msg->mailaddress;
    if( client->mode == MODE_NEUTRAL ) {
        client->mode = MODE_SELECTENEMY;
    }
} /* MsgGame */

/* ** Func MsgChallengerlist ********************************** */
/* Say what func this is */
void MsgChallengerlist( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTENEMY )
        if( SendChallengerlist( client ) )
            DeleteClient( client );
} /* MsgChallengerlist */

/* ** Func MsgChallenge ********************************** */
/* Say what func this is */
void MsgChallenge( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTENEMY ) {
        /* if the clinet is already 
           selecting or selected... */
        if( client->Selecting != NULL ||
            client->Selected != NULL ) {
            if( SendBusy( client ) ) DeleteClient( client );
            /* if the clinet is not yet 
               selecting or selected... */
        } else {
            CLIENTDATA *applied;
            applied = MatchSocket( msg->num );
            if( applied == NULL ) {
                /* if applied client does not exist... */
                if( SendNotExist( client ) ) DeleteClient( client );
            } else if( applied == client ) {
                if( SendNotExist( client ) ) DeleteClient( client );
            } else if( applied->mode != MODE_SELECTENEMY ){
                if( SendNotExist( client ) ) DeleteClient( client );
            } else {
                /* if applied client is found... */
                if( applied->Selecting != NULL ||
                    applied->Selected != NULL ) {
                    if( SendBusy( client ) ) DeleteClient( client );
                } else {
                    client->Selecting = applied;
                    applied->Selected = client;
                    if( SendChallenged( applied, client ) ) {
                        /* applied client has disappeared... */
                        DeleteClient( applied );
                        if( SendNotExist( client ) ) DeleteClient( client );
                    }
                }
            }
        }
    }
} /* MsgChallenge */

/* ** Func MsgAccept ********************************** */
/* Say what func this is */
void MsgAccept( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTENEMY ) {
        if( client->Selected != NULL ) {
            if( InRandomMode ) {
                if( boolrand() ) {
                    InitGame( client->Selected, client );
                } else {
                    InitGame( client, client->Selected );
                }
            } else {
                InitGame( client->Selected, client );
            }
        } else {
            if( SendNotExist( client ) ) DeleteClient( client );
        }
    }
} /* MsgAccept */

/* ** Func MsgRefuse ********************************** */
/* Say what func this is */
void MsgRefuse( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTENEMY ) {
        if( client->Selected != NULL ) {
            if( SendRefused( client->Selected ) ) {
                DeleteClient( client->Selected );
            } else {
                client->Selected->Selecting = NULL;
                client->Selected = NULL;
            }
        }
    }
} /* MsgRefuse */

/* ** Func MsgMoveAndDrop ********************************** */
/* Say what func this is */
void MsgMoveAndDrop( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
    JUDGE judge;
    JUDGERESULT result;
    NOTATION_HANDDATA NotationHandData;
    CLIENTDATA *enemy;
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_GAME &&
        client == client->game->CurrentPlayer ) {
        result = ExamineHand( client->game, msg, &judge );
        switch( result ) {
          case OK:
            /* Save Hand Data for Notation */
            if( msg->key == MOVE ) {
                NotationHandData.key = NOTATION_MOVE;
                if( judge.isCaptured ) {
                    NotationHandData.isCaptured = TRUE;
                    memcpy( &NotationHandData.capture,
                            &judge.capture, sizeof(CAPTURESTATE) );
                } else {
                    NotationHandData.isCaptured = FALSE;
                }
            } else if( msg->key == DROP ) {
                NotationHandData.key = NOTATION_DROP;
            }
            memcpy( &NotationHandData.hand, &msg->hand,
                    sizeof( HANDDATA ) );
            NotationHandData.isChecked = judge.isCheck;
            NotationHandData.isViolate = FALSE;
            AddHand( client->game, &NotationHandData );
            /* Send Hand Data to Viewer */
            SendEachViewerHandData( client->game, &NotationHandData );
            /* Send Message to Client */
            if( judge.isCaptured ) {
                if( SendOk( client, judge.capture.piece, judge.isCheck ) )
                    MsgQuit( client, msg );
            } else {
                if( SendOk( client, NONE, judge.isCheck ) )
                    MsgQuit( client, msg );
            }
            FlipPlayer( client->game );
            if( judge.isCaptured ) {
                if( SendNext( client->game->CurrentPlayer,
                              judge.isCaptured,
                              judge.capture.x, judge.capture.y,
                              judge.isCheck ) ) {
                    MsgQuit( client, msg );
                }
            } else {
                if( SendNext( client->game->CurrentPlayer,
                              judge.isCaptured, 0, 0, judge.isCheck ) ) {
                    MsgQuit( client, msg );
                }
            }
            break;
          case ILLEGAL:
            if( SendIllegal( client ) )
                MsgQuit( client, msg );
            break;
          case VIOLATE:
            /* Save Hand Data for Notation */
            if( msg->key == MOVE ) {
                NotationHandData.key = NOTATION_MOVE;
            } else if( msg->key == DROP ) {
                NotationHandData.key = NOTATION_DROP;
            }
            memcpy( &NotationHandData.hand, &msg->hand, sizeof( HANDDATA ) );
            NotationHandData.isCaptured = FALSE;
            NotationHandData.isViolate = TRUE;
            NotationHandData.violation = judge.violation;
            AddHand( client->game, &NotationHandData );
            /* Send Hand Data to Viewer */
            SendEachViewerHandData( client->game, &NotationHandData );
            /* Send Message to Client */
            if( SendViolate( client, judge.violation ) )
                MsgQuit( client, msg );
            if( SendEnemyViolate( THEOTHERPLAYER( client ) ) )
                MsgQuit( THEOTHERPLAYER( client ), msg );
            break;
          case END:
            /* Save Hand Data for Notation */
            if( msg->key == MOVE ) {
                NotationHandData.key = NOTATION_MOVE;
                if( judge.isCaptured ) {
                    NotationHandData.isCaptured = TRUE;
                    memcpy( &NotationHandData.capture,
                            &judge.capture, sizeof(CAPTURESTATE) );
                } else {
                    NotationHandData.isCaptured = FALSE;
                }
            } else if( msg->key == DROP ) {
                NotationHandData.key = NOTATION_DROP;
            }
            memcpy( &NotationHandData.hand, &msg->hand, sizeof( HANDDATA ) );
            if( judge.endstate.reason == LOSTLIFE ) {
                NotationHandData.isViolate = TRUE;
                NotationHandData.violation = judge.violation;
            } else {
                NotationHandData.isViolate = FALSE;
            }
            AddHand( client->game, &NotationHandData );
            /* Send Hand Data to Viewer */
            SendEachViewerHandData( client->game, &NotationHandData );
            /* Save END Hand for NOTATION */
            NotationHandData.key = NOTATION_END;
            if( judge.endstate.winner == client->game->Black ) {
                NotationHandData.winner = BLACK;
            } else {
                NotationHandData.winner = WHITE;
            }
            NotationHandData.reason_of_end = judge.endstate.reason;
            AddHand( client->game, &NotationHandData );
            /* Send END Hand Data to Viewer */
            SendEachViewerHandData( client->game, &NotationHandData );
            /* Send Message to Client */
            enemy = client->game->NonCurrentPlayer;
            if( judge.endstate.winner == client ) {
                SendEndID( client, WIN, judge.endstate.reason );
                SendEndID( enemy, LOSE, judge.endstate.reason );
            } else {
                SendEndID( client, LOSE, judge.endstate.reason );
                SendEndID( enemy, WIN, judge.endstate.reason );
            }
            SendEndData( client, client->game );
            SendEndData( enemy, client->game );
            /* SaveNotation into file */
            SaveNotation( client->game );
            /* CleanUpData and CloseConnection */
            CleanGame( client->game );
            break;
          default:
            break;
        }
    }
} /* MsgMoveAndDrop */

/* ** Func MsgGiveup ********************************** */
/* Say what func this is */
void MsgGiveup( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
    NOTATION_HANDDATA NotationHandData;
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_GAME ) {
        /* Save Hand Data for Notation */
        NotationHandData.key = NOTATION_END;
        if( client == client->game->Black ) {
            NotationHandData.winner = WHITE;
        } else {
            NotationHandData.winner = BLACK;
        }
        NotationHandData.reason_of_end = GAVEUP;
        AddHand( client->game, &NotationHandData );
        /* Send END Hand Data to Viewer */
        SendEachViewerHandData( client->game, &NotationHandData );
        /* Send Message to Client */
        if( !SendEndID( client, LOSE, GAVEUP ) ) {
            SendEndData( client, client->game );
        }
        if( !SendEndID( THEOTHERPLAYER(client), WIN, GAVEUP ) ) {
            SendEndData( THEOTHERPLAYER(client),client->game );
        }
        /* SaveNotation into file */
        SaveNotation( client->game );
        /* Game Finish */
        CleanGame( client->game );
    }
} /* MsgGiveup */

/* ** Func MsgCheat ********************************** */
/* Say what func this is */
void MsgCheat( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
    PIECE piece;
    SIDE side;
    int isPromoted;
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_GAME ) {
        Cheat( client->game, msg->hand.move.sx, msg->hand.move.sy,
               &piece, &side, &isPromoted );
        if( SendCheat( client, side, piece, isPromoted ) )
            DeleteClient( client );
    }
} /* MsgCheat */

/* ** Func MsgView ********************************** */
/* Say what func this is */
void MsgView( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_NEUTRAL ) {
        client->mode = MODE_SELECTGAME;
    }
} /* MsgView */

/* ** Func MsgNotation ********************************** */
/* Say what func this is */
void MsgNotation( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_NEUTRAL ) {
        client->mode = MODE_SELECTNOTATION;
    }
} /* MsgNotation */

/* ** Func MsgManagenotation ********************************** */
/* Say what func this is */
void MsgManagenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_NEUTRAL ) {
        client->mode = MODE_MANAGENOTATION;
    }
} /* MsgManagenotation */

/* ** Func MsgGamelist ********************************** */
/* Say what func this is */
void MsgGamelist( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTGAME ) {
        if( SendGameList( client ) ) DeleteClient( client );
    }
} /* MsgGamelist */

/* ** Func MsgViewgame ********************************** */
/* Say what func this is */
void MsgViewgame( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
    GAMEDATA *game;
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTGAME ) {
        game = MatchGameId( msg->num );
        if( game != NULL ) {
            client->mode = MODE_VIEW;
            AddViewer( game, client );
            if( SendViewStart( client ) )
                DeleteViewer( game, client );
            if( SendCurrentHandsForViewer( client ) )
                DeleteViewer( game, client );
        } else {
	    SendNotExist( client );
	}
    }
} /* MsgViewgame */

/* ** Func MsgNotationlist ********************************** */
/* Say what func this is */
void MsgNotationlist( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTNOTATION ) {
        if( SendNotationList( client, FALSE ) ) DeleteClient( client );
    } else if( client->mode == MODE_MANAGENOTATION ) {
        if( SendNotationList( client, TRUE ) ) DeleteClient( client );
    }
} /* MsgNotationlist */

/* ** Func MsgViewnotation ********************************** */
/* Say what func this is */
void MsgViewnotation( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_SELECTNOTATION ) {
        if( SendNotation( client, msg->num ) ) { /* Error occurs */
            SendNotExist( client );
        }
        RemoveClient( client );
    }
} /* MsgViewnotation */

/* ** Func MsgDeletenotation ********************************** */
/* Say what func this is */
void MsgDeletenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_MANAGENOTATION ) {
        DeleteNotation( msg->num );
    }
} /* MsgDeletenotation */

/* ** Func MsgSavenotation ********************************** */
/* Say what func this is */
void MsgSavenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_MANAGENOTATION ) {
        AddSavePropertyToNotation( msg->num );
    }
} /* MsgSavenotation */

/* ** Func MsgUnsavenotation ********************************** */
/* Say what func this is */
void MsgUnsavenotation( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode == MODE_MANAGENOTATION ) {
        RemoveSavePropertyFromNotation( msg->num );
    }
} /* MsgUnsavenotation */

/* ** Func MsgError ********************************** */
/* Say what func this is */
void MsgError( CLIENTDATA *client, CLIENT_MESSAGE *msg )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
    if( client->mode != MODE_GET ) Err( "Error in ReadMessage." );
} /* MsgError */

/* ** Func boolrand ********************************** */
/* Return 1 or 0 randomly. */
int boolrand( void )
{
/* -- Local Data --------------------------------- */
/* -- Operation ---------------------------------- */
#ifdef RAND_MAX
    return ( ( (double)rand() / (double)RAND_MAX ) < 0.5 ) ? 1 : 0;
#else
    return ( (double)( rand() & 0xffffff ) / (double) 0xffffff < 0.5 ) ? 1: 0;
#endif
} /* boolrand */

/* ** Func TerminateAllGames ********************* */
/*
 * Terminate All Games.
 * Game is terminated with reason EMERGENCE.
 * Send each client appropriate message,
 * and close all connections.
 */
void TerminateAllGames( void )
{
/* -- Local Data --------------------------------- */
    NOTATION_HANDDATA NotationHandData;
    GAMEDATA *game;
/* -- Operation ---------------------------------- */
    game = GameList;
    while( game != NULL ) {
        /* Save Hand Data for Notation */
        NotationHandData.key = NOTATION_END;
        NotationHandData.winner = NOSIDE;
        NotationHandData.reason_of_end = EMERGENCE;
        AddHand( game, &NotationHandData );
        /* Send END Hand Data to each viewer */
        SendEachViewerHandData( game, &NotationHandData );
        /* Send Message to Client */
        if( !SendEndID( game->Black, DRAW, EMERGENCE ) )
            SendEndData( game->Black, game );
        if( !SendEndID( game->White, DRAW, EMERGENCE ) )
            SendEndData( game->White, game );
        /* SaveNotation into file */
        SaveNotation( game );
        /* Game Finish */
        CleanGame( game );
        game = game->Next;
    }
} /* TerminateAllGames */



