/* ** protocol.h ********************************* */
/* TUITATE PROTOCOL Declerations                   */
/* *********************************************** */
#ifndef _PROTOCOL_H_
#define _PROTOCOL_H_

/* -- Include File ------------------------------- */

/* -- Macro Definition --------------------------- */

/* *** Client -> Server ************************* */

#define KEY_MODE		"MODE"		/* <Mode : ALL> */
#define KEY_HELP		"HELP"		/* <Mode : ALL> */
#define KEY_QUIT		"QUIT"		/* <Mode : ALL> */

#define KEY_GAME		"GAME"		/* <Mode : NEUTRAL> */
#define KEY_VIEW		"VIEW"		/* <Mode : NEUTRAL> */
#define KEY_NOTATION		"NOTATION"	/* <Mode : NEUTRAL> */
#define KEY_MANAGENOTATION	"MANAGENOTATION"/* <Mode : NEUTRAL> */
#define KEY_GET			"GET"		/* <Mode : NEUTRAL> */

#define KEY_CHALLENGERLIST	"CHALLENGERLIST"/* <Mode : SELECTENEMY> */
#define KEY_CHALLENGE		"CHALLENGE"	/* <Mode : SELECTENEMY> */
#define KEY_ACCEPT		"ACCEPT"	/* <Mode : SELECTENEMY> */
#define KEY_REFUSE		"REFUSE"	/* <Mode : SELECTENEMY> */

#define KEY_MOVE		"MOVE"		/* <Mode : GAME> */
#define KEY_DROP		"DROP"		/* <Mode : GAME> */
#define KEY_GIVEUP		"GIVEUP"	/* <Mode : GAME> */
#define KEY_CHEAT		"CHEAT" 	/* <Mode : GAME> */

#define KEY_GAMELIST		"GAMELIST"	/* <Mode : SELECTGAME> */
#define KEY_VIEWGAME		"VIEWGAME"	/* <Mode : SELECTGAME> */

#define KEY_NOTATIONLIST        "NOTATIONLIST"  /* <Mode : SELECTNOTATION> */
#define KEY_VIEWNOTATION        "VIEWNOTATION"  /* <Mode : SELECTNOTATION> */

#define KEY_DELETENOTATION      "DELETENOTATION"/* <Mode : MANAGENOTATION> */
#define KEY_SAVENOTATION        "SAVENOTATION"  /* <Mode : MANAGENOTATION> */
#define KEY_UNSAVENOTATION      "UNSAVENOTATION"/* <Mode : MANAGENOTATION> */

#define KEY_EMPTYLINE           "EMPTYLINE"     /* <to impliment easily> */
#define KEY_NOTYETONEPACKET     "NOTYETONEPACKET"/* <to impliment easily> */
#define KEY_EMERGENCY           "EMERGENCY"     /* <to impliment easily> */
#define KEY_ERROR               "ERROR"         /* <to impliment easily> */

/* --- */

/* for GAME (promotion) */
#define STR_PROMOTE	"PROMOTE"
#define STR_NOTPROMOTE	"NOTPROMOTE"

/* for GAME (kind_of_piece) */
#define STR_NONE	"NONE"
#define STR_PAWN	"PAWN"
#define STR_LANCE	"LANCE"
#define STR_KNIGHT	"KNIGHT"
#define STR_SILVER	"SILVER"
#define STR_GOLD	"GOLD"
#define STR_BISHOP	"BISHOP"
#define STR_ROOK	"ROOK"
#define STR_KING	"KING"

/* for GET */
#define GET_END "HTTP/1."

/* *** Server -> Cleint ******************************** */

#ifndef KEY_CHALLENGERLIST
#define KEY_CHALLENGERLIST	"CHALLENGERLIST"
#endif
#define KEY_CHALLENGED	"CHALLENGED" /* [name] [mailaddress] */
#define KEY_NOTEXIST	"NOTEXIST"
#define KEY_BUSY	"BUSY"
#define KEY_REFUSED	"REFUSED"

#define KEY_START	"START"			/* side */
#define KEY_NEXT 	"NEXT"			/* [CHECKED] */
#define KEY_ENEMYVIOLATE 	"ENEMYVIOLATE"
#define KEY_OK		"OK"			/* [kind_of_piece] CHECK */
#define KEY_ILLEGAL	"ILLEGAL"
#define KEY_VIOLATE	"VIOLATE" 		/* kind_of_violation */
#define KEY_END		"END"			/* result reason_of_end */

#ifndef KEY_GAMELIST
#define KEY_GAMELIST	"GAMELIST"
#endif
#define KEY_VIEWSTART	"VIEWSTART"

#ifndef KEY_NOTATIONLIST
#define KEY_NOTATIONLIST	"NOTATIONLIST"
#endif

#ifndef KEY_CHEAT
#define KEY_CHEAT	"CHEAT"
#endif

/* --- */

/* for START (side) */
#define STR_BLACK	"BLACK"
#define STR_WHITE	"WHITE"
#define STR_NOSIDE	"NOSIDE"

/* for NEXT */
#define STR_CHECKED	"CHECKED"

/* for VIOLATION (kind_of_violation) */
#define STR_JUMPOVER	"JUMPOVER"
#define STR_CHECK	"CHECK"
#define STR_DROPON	"DROPON"
#define STR_CHECKMATEBYDROPPINGPAWN	"CHECKMATEBYDROPPINGPAWN"

/* for END (result, reason_of_end) */
#define STR_WIN		"WIN"
#define STR_LOSE	"LOSE"
#define STR_DRAW	"DRAW"
#define STR_CHECKMATE	"CHECKMATE"
#define STR_LOSELIFE	"LOSELIFE"
#define STR_GIVEUP	"GIVEUP"
#define STR_EMERGENCY	"EMERGENCY"

/* GAMELIST */
#define STR_UNKNOWN	"UNKNOWN"

/* for VIEW DATA */
#define STR_NOTCHECKED	"NOTCHECKED"

/* for NOTATIONLIST */
#define STR_SAVE        "SAVE"

/* -- Type Decleration --------------------------- */
typedef enum {
    MODE,		/* <Mode : ALL> */
    HELP,		/* <Mode : ALL> */
    QUIT,		/* <Mode : ALL> */

    GAME,		/* <Mode : NEUTRAL> */
    VIEW,		/* <Mode : NEUTRAL> */
    NOTATION,		/* <Mode : NEUTRAL> */
    MANAGENOTATION,	/* <Mode : NEUTRAL> */
    GET,		/* <Mode : NEUTRAL> */

    CHALLENGERLIST,	/* <Mode : SELECTENEMY> */
    CHALLENGE,		/* <Mode : SELECTENEMY> */
    ACCEPT,		/* <Mode : SELECTENEMY> */
    REFUSE,		/* <Mode : SELECTENEMY> */
	
    MOVE,		/* <Mode : GAME> */
    DROP,		/* <Mode : GAME> */
    GIVEUP,		/* <Mode : GAME> */
    CHEAT,		/* <Mode : GAME> */

    GAMELIST,		/* <Mode : SELECTGAME> */
    VIEWGAME,		/* <Mode : SELECTGAME> */

    NOTATIONLIST,       /* <Mode : NOTATIONLIST> */
    VIEWNOTATION,       /* <Mode : NOTATIONLIST> */

    DELETENOTATION,     /* <Mode : MANAGENOTATION> */
    SAVENOTATION,       /* <Mode : MANAGENOTATION> */
    UNSAVENOTATION,     /* <Mode : MANAGENOTATION> */
   
    EMPTYLINE,          /* <Mode : NEWTRAL> */

    NOTYETONEPACKET,    /* <Mode : ALL > */

    EMERGENCY,		/* ERROR Connection closed */
    ERROR,			/* ERROR */

    MSGKEY_NUM,		/* Number of MsgKey */
} CLIENT_MSGKEY;

typedef enum {
    NONE,
    PAWN,
    LANCE,
    KNIGHT,
    SILVER,
    GOLD,
    BISHOP,
    ROOK,
    KING,
    PIECE_NUM,
} PIECE;

typedef struct _MOVEDATA {
    int sx;
    int sy;
    int dx;
    int dy;
    int willPromote;
} MOVEDATA;

typedef struct _DROPDATA {
    int dx;
    int dy;
    PIECE piece;
} DROPDATA;

typedef union _HANDDATA {
    MOVEDATA move;
    DROPDATA drop;
} HANDDATA;

typedef struct _CLIENT_MESSAGE {
    CLIENT_MSGKEY key;
    HANDDATA hand;
    int num;
    char *name;
    char *mailaddress;
} CLIENT_MESSAGE;

typedef enum {
    BLACK,
    WHITE,
    NOSIDE,
} SIDE;

typedef enum {
    JUMPOVER,
    CHECK,
    DROPON,
    CHECKMATEBYDROPPINGPAWN,
    VIOLATION_NUM,
} VIOLATION;

typedef enum {
    WIN,
    LOSE,
    DRAW,
} RESULT;

typedef enum {
    CHECKMATED,
    LOSTLIFE,
    GAVEUP,
    EMERGENCE,
    REASON_OF_END_NUM,
} REASON_OF_END;

/* -- External Data ------------------------------ */

extern char *PieceStr[];
extern char *ViolationStr[];
extern char *ReasonOfEndStr[];
extern char *ClientMessageStr[];

#endif _PROTOCOL_H_

