/* ** sendmessage.h ****************************** */
/* Declerations to send message to clients         */
/* *********************************************** */
#ifndef _SENDMESSAGE_H_
#define _SENDMESSAGE_H_

/* -- Include File ------------------------------- */
#include "struct.h"
#include "clientlist.h"
#include "notation.h"
#include "protocol.h"

/* -- External Data ------------------------------ */

/* -- Protype Declerations  ---------------------- */
extern int SendMessage( CLIENTDATA *p );
extern int SendHelp( CLIENTDATA *p );
extern int SendMode( CLIENTDATA *p );
extern int SendChallengerlist( CLIENTDATA *p );
extern int SendNotExist( CLIENTDATA * p );
extern int SendBusy( CLIENTDATA * p );
extern int SendRefused( CLIENTDATA * p );
extern int SendStart( CLIENTDATA *p, SIDE side );
extern int SendChallenged( CLIENTDATA *p, CLIENTDATA *challenger );
extern int SendOk( CLIENTDATA *p, PIECE gotten, int isCheck );
extern int SendNext(CLIENTDATA * p,int isCaptured,
				int CapturedX,int CapturedY,int isChecked);
extern int SendEnemyViolate( CLIENTDATA * p );
extern int SendIllegal( CLIENTDATA *p );
extern int SendViolate( CLIENTDATA *p, VIOLATION kind_of_violation );
extern int SendEndID(CLIENTDATA *p, RESULT result,REASON_OF_END reason_of_end);
extern int SendEndData( CLIENTDATA * p, GAMEDATA *game );
extern int SendGameList( CLIENTDATA * p );
extern int SendViewStart( CLIENTDATA * p );
extern int SendViewHandData( CLIENTDATA *p, const NOTATION_HANDDATA *data );
extern int SendNotationList( CLIENTDATA * p, int toManager );
extern int SendNotation( CLIENTDATA *client, int NotationID );
extern int SendCurrentHandsForViewer( CLIENTDATA *p );
extern int SendEachViewerHandData( GAMEDATA *game, NOTATION_HANDDATA *data );

extern void HandDataToMsg( const NOTATION_HANDDATA *data, char *msg );
extern int SendFile( CLIENTDATA *p, char *filename );

extern int SendCheat( CLIENTDATA *client, SIDE side, PIECE piece, int isPromoted );


#endif _SENDMESSAGE_H_
